# Generated by Django 4.2 on 2023-04-21 17:07

import django.db.models.deletion
import django.utils.timezone
import model_utils.fields
from django.db import migrations, models


class Migration(migrations.Migration):
    dependencies = [
        ("literature", "0003_literature_csl"),
    ]

    operations = [
        migrations.RemoveField(
            model_name="literature",
            name="DOI",
        ),
        migrations.RemoveField(
            model_name="literature",
            name="ISBN",
        ),
        migrations.RemoveField(
            model_name="literature",
            name="ISSN",
        ),
        migrations.RemoveField(
            model_name="literature",
            name="PMCID",
        ),
        migrations.RemoveField(
            model_name="literature",
            name="PMID",
        ),
        migrations.AddField(
            model_name="literature",
            name="PID",
            field=models.CharField(blank=True, max_length=512, null=True, verbose_name="Permanent Identifier"),
        ),
        migrations.AddField(
            model_name="literature",
            name="PID_type",
            field=models.IntegerField(blank=True, null=True, verbose_name="PID Type"),
        ),
        migrations.CreateModel(
            name="Identifier",
            fields=[
                (
                    "created",
                    model_utils.fields.AutoCreatedField(
                        default=django.utils.timezone.now, editable=False, verbose_name="created"
                    ),
                ),
                (
                    "modified",
                    model_utils.fields.AutoLastModifiedField(
                        default=django.utils.timezone.now, editable=False, verbose_name="modified"
                    ),
                ),
                (
                    "ID",
                    models.CharField(
                        max_length=512, primary_key=True, serialize=False, verbose_name="Permanent Identifier"
                    ),
                ),
                (
                    "type",
                    models.IntegerField(
                        choices=[(0, "DOI"), (1, "ISSN"), (2, "ISBN"), (3, "PMCID"), (4, "PMID"), (5, "URL")]
                    ),
                ),
                (
                    "literature",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="literature.literature",
                        verbose_name="literature",
                    ),
                ),
            ],
            options={
                "verbose_name": "ID",
                "verbose_name_plural": "IDs",
                "default_related_name": "identifiers",
                "unique_together": {("ID", "literature")},
            },
        ),
    ]
